<template>
  <el-main>
    <el-row>
      <el-col :span="12">
        <label>テンプレート</label>
      </el-col>
      <el-col :span="12">
        <label>入力タイプ: </label>
        <el-select v-model="input_type">
          <el-option key="text"          label="text"            value="text"></el-option>
          <el-option key="json"          label="json"            value="json"></el-option>
          <el-option key="csv"           label="csv"             value="csv"></el-option>
          <el-option key="csv_no_header" label="csv (no header)" value="csv_no_header"></el-option>
          <el-option key="tsv"           label="tsv"             value="tsv"></el-option>
          <el-option key="tsv_no_header" label="tsv (no header)" value="tsv_no_header"></el-option>
        </el-select>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="12">
        <el-input type="textarea" :rows="10" placeholder="SELECT ID, NAME FROM ${TABLE} WHERE ID = ${ID};

text: ${0}
csv,tsv,json: ${&lt;column_name&gt;}
csv,tsv no header: ${&lt;column_number&gt;}" v-model="template"></el-input>
      </el-col>
      <el-col :span="12">
        <el-input type="textarea" :rows="10" placeholder="TABLE,ID
USER,123
ITEM,456
" v-model="input"></el-input>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="4" :offset="10">
        <el-button @click="convert" type="primary" round>変換！</el-button>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="24">
        <el-input type="textarea" :rows="10" placeholder="SELECT ID, NAME FROM USER WHERE ID = 123;
SELECT ID, NAME FROM ITEM WHERE ID = 456;" v-model="output"></el-input>
      </el-col>
    </el-row>
  </el-main>
</template>

<script>
import _ from 'lodash';

export default {
  data() {
    return {
      template: "",
      input_type: "tsv",
      input: '',
      output: "",
    }
  },
  methods: {
    convert() {
      const data = this.splitInputData(this.input, this.input_type)
      this.output = this.templatingByData(this.template, data)
    },

    templatingByData(tmpl, data) {
      let retVal = ""
      let matches = tmpl.match(/(?:\$\{)([^}]+?)(?:\})/gm)

      if (!_.isArray(data)) {
        this.$message({
          showClose: true,
          message: "データが配列ではありません",
          type: "error"
        })
        return ""
      }

      _.forEach(data, (d) => {
        let tmp = tmpl

        _.forEach(matches, (m) => {
          const key = m.slice(2, -1)
          const pattern = new RegExp(_.escapeRegExp(m), "gm")
          tmp = tmp.replace(pattern, (d[key] || m))
        })

        retVal += tmp + "\n"
      })

      return retVal
    },

    splitInputData(input, type) {
        const lineSplitter = "\n"

        if (type == "json") {
          try {
            const data = JSON.parse(input)

            if (_.isArray(data)) {
              return data
            } else {
              throw Error("JSONが配列になっていません")
            }
          } catch(e) {
            this.$message({
              showClose: true,
              message: e.message,
              type: "error"
            })
            return []
          }
        }

        console.log("hoge")
        const lines = input.split(lineSplitter)
        const values = _.map(lines, (line) => this.parseLine(line, type))

        if (type === "text" || _.includes(type, "no_header")) {
          return values
        } else {
          const mapping = []
          const header = values.shift()

          for (let data of values) {
            if (header.length != data.length) {
              this.$message({
                showClose: true,
                message: "ヘッダーの数とデータの数が合いません",
                type: "error"
              })
              continue
            }

            const hash = _.zipObject(header, data)
            mapping.push(hash)
          }

          return mapping
        }
      },

      parseLine(line, type) {
        if (type === "text") return [line]

        const delimiter = _.includes(type, "csv")? "," : "\t"

        return line.split(delimiter)
      }
  }
}
</script>